#include <stdio.h>

#include <timer.h>
#include <ports.h>

#include "HardwareProfile.h"
#include "generictypedefs.h"
#include "swi2c.h"

#include <libpic30.h>

#include "usb_gen_funz.h"


extern volatile WORD tick10;
extern volatile BYTE second_10;
BYTE divider1s;
extern volatile DWORD milliseconds;



/** VECTOR REMAPPING ***********************************************/
    #if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
        /*
         *	ISR JUMP TABLE
         *
         *	It is necessary to define jump table as a function because C30 will
         *	not store 24-bit wide values in program memory as variables.
         *
         *	This function should be stored at an address where the goto instructions 
         *	line up with the remapped vectors from the bootloader's linker script.
         *  
         *  For more information about how to remap the interrupt vectors,
         *  please refer to AN1157.  An example is provided below for the T2
         *  interrupt with a bootloader ending at address 0x1400
         */
//        void __attribute__ ((address(0x1404))) ISRTable(){
//        
//        	asm("reset"); //reset instruction to prevent runaway code
//        	asm("goto %0"::"i"(&_T2Interrupt));  //T2Interrupt's address
//        }
    #endif


// ---------------------------------------------------------------------------------------
void _ISR __attribute__((__no_auto_psv__)) _AddressError(void) {
	Nop();
	Nop();
	}

void _ISR __attribute__((__no_auto_psv__)) _StackError(void) {
	Nop();
	Nop();
	}
	

void __attribute__ (( interrupt, /*shadow*/,  no_auto_psv )) _T2Interrupt(void) {
// dev'essere 10Hz

//	WriteTimer2(0);	// WRITETIMER0(0) dovrebbe essere la macro!
//  TMR2=0;		non serve su PIC24...
//	mLED_1_Toggle(); 
//	SD_CS^=1;

	tick10++;
	divider1s++;

	second_10=1;					// flag
	if(divider1s==10) {		// per RealTimeClock
		divider1s=0;

		}

	IFS0bits.T2IF = 0; 			//Clear the Timer2 interrupt status flag
	// non lo trova @#$% T2_Clear_Intr_Status_Bit; 	
	}



void __attribute__ (( interrupt, shadow,  no_auto_psv )) _T3Interrupt(void) {
	static BYTE sampleCnt;
	static const WORD *ptr=samplesTable;
  static WORD lfsr = 0xACE1u;
	BYTE b;
//uso ptr per velocizzare!
// potremmo essere sulle 13-15 istruzioni in tutto...200nS; usando ASM direi anche 11 ossia 160

//	mLED_1_Toggle(); 
/* jump table in assembler, v. forum
void func(int j);*/
__asm__ (

//".globl _func\n"
 
".equ arg_Index,w0\n"
 
//_func:
//*** sl arg_Index,arg_Index if gotos ***
"mov   #0,w0\n"
"mov.b   _configParms+2,wreg\n"
"bra     w0\n"
"bra     label_NESSUNA\n"
"bra     label_QUADRA\n"
"bra     label_TRIANGOLARE\n"
"bra     label_SAWTOOTH\n"
"bra     label_SINUSOIDALE\n"
"bra     label_IMPULSI\n"
"bra     label_RUMORE_BIANCO\n"
"bra     label_RUMORE_ROSA\n"
);
//asm volatile("mov.b W0, _LATA");
//asm volatile("mov.b _configParms+2, WREG");

	switch(configParms.tipoOnda) {
		case NESSUNA:
__asm__ ("label_NESSUNA:");
			break;
		case QUADRA:
__asm__ ("label_QUADRA:");
			break;
		case TRIANGOLARE:
__asm__ ("label_TRIANGOLARE:");
			sampleCnt++;
//		  OC1RS   = samplesTable /*TRIANGLE_WAVE_TABLE*/[sampleCnt++];
		  OC1R   = *ptr++;
			break;
		case SAWTOOTH:
__asm__ ("label_SAWTOOTH:");
			sampleCnt++;
//		  OC1RS   = samplesTable /*SAWTOOTH_WAVE_TABLE*/[sampleCnt++];
		  OC1R   = *ptr++;
			break;
		case SINUSOIDALE:
__asm__ ("label_SINUSOIDALE:");
			sampleCnt++;
//		  OC1RS   = samplesTable /*SINE_WAVE_TABLE*/[sampleCnt++];
		  OC1R   = *ptr++;
			break;
		case IMPULSI:
__asm__ ("label_IMPULSI:");
			break;
		case RUMORE_BIANCO:
__asm__ ("label_RUMORE_BIANCO:");
//		  OC1RS   = (FCY/1000000L*rand())/RAND_MAX;
	    b  = ((lfsr >> 0) ^ (lfsr >> 2) ^ (lfsr >> 3) ^ (lfsr >> 5) ) & 1;
  	  lfsr =  (lfsr >> 1) | (b << 15);
			OC1R = lfsr >> 10;		// basato su 64
			break;
		case RUMORE_ROSA:			// filtrare...
__asm__ ("label_RUMORE_ROSA:");
//		  OC1RS   = (FCY/1000000L*rand())/RAND_MAX;
	    b  = ((lfsr >> 0) ^ (lfsr >> 2) ^ (lfsr >> 3) ^ (lfsr >> 5) ) & 1;
  	  lfsr =  (lfsr >> 1) | (b << 15);
			OC1R = lfsr >> 10;		// basato su 64
			break;
		}

//	sampleCnt &= NUM_SAMPLES-1;
//	if(sampleCnt >= NUM_SAMPLES) {
	if(sampleCnt & 0x10) {
		sampleCnt=0;
		ptr=samplesTable;
		}	

	IFS0bits.T3IF = 0; 			//Clear the Timer3 interrupt status flag
	// non lo trova @#$% T3_Clear_Intr_Status_Bit; 	
	}


