


#define SERNUM      1000
#define VERNUMH     1
#define VERNUML     1


//#define FLASH_TIME 7
#define USA_SW_RTC 1



// il Timer0 conta ogni 62.5nSec*prescaler... (@32MHz CPUCLK => 16MHz) su PIC24
#define TMR2BASE (25010 /*6260*/-11)		//   10Hz per timer
#define TMR3BASE_1 (10)		//   7000KHz per PWM "lento"
#define TMR3BASE_2 (100)	//   700KHz per PWM "lento" 2
#define TMR3BASE_3 (1000)	//   70KHz per PWM "lento" 3
#define TMR4BASE (70)		//   1000000Hz per timestamp

enum TIPO_ONDA {
	NESSUNA,
	QUADRA,
	TRIANGOLARE,
	SAWTOOTH,
	SINUSOIDALE,
	IMPULSI,
	RUMORE_BIANCO,
	RUMORE_ROSA
	};
struct SAVED_PARAMETERS {
	WORD signature;
	BYTE tipoOnda;
	WORD dutyCycle;
	DWORD Frequenza;			// decimi di Hz
	BYTE Amplitude;
	};

extern struct SAVED_PARAMETERS configParms;
#define PARMS_FIELD(field) configParms.field
BYTE EEleggi(BYTE);
void EEscrivi_(BYTE,BYTE);


#define NUM_SAMPLES 16
extern const WORD TRIANGLE_WAVE_TABLE[NUM_SAMPLES];
extern const WORD SINE_WAVE_TABLE[NUM_SAMPLES];
extern const WORD SAWTOOTH_WAVE_TABLE[NUM_SAMPLES];
extern WORD samplesTable[NUM_SAMPLES];

#define BEEP_STD_FREQ 1000

#define EEcopiaARAM(p) { *p=EEleggi(p); }
#define EEcopiaAEEPROM(p) EEscrivi_(p,*p)

void saveSettings(void);
void loadSettings(void);
void resetSettings(void);




void prepOutBuffer(BYTE );
void clearOutBuffer(void);
void prepStatusBuffer(BYTE);


	
#define DELAY_SPI_FAST 5
#define Delay08()	__delay_us(TIME_GRANULARITY)			// 1 bit-time 
#define Delay_SPI() __delay_us(DELAY_SPI_FAST /*DelaySPIVal*/)
#define Delay_1uS() __delay_us(1)
#define Delay_uS(x) __delay_us(x)
#define Delay_mS(x) __delay_ms(x)
#define Delay_1mS() Delay_mS(1)
void Delay_mS_LP(BYTE);
void I2CDelay(void);




void Beep(void);


void UserTasks(void);



    // PIC24 RTCC Structure
typedef union {
  struct {
    unsigned char   mday;       // BCD codification for day of the month, 01-31
    unsigned char   mon;        // BCD codification for month, 01-12
    unsigned char   year;       // BCD codification for years, 00-99
    unsigned char   reserved;   // reserved for future use. should be 0
  	};                              // field access	
  unsigned char       b[4];       // byte access
  unsigned short      w[2];       // 16 bits access
  unsigned long       l;          // 32 bits access
	} PIC24_RTCC_DATE;

// PIC24 RTCC Structure
typedef union {
  struct {
    unsigned char   sec;        // BCD codification for seconds, 00-59
    unsigned char   min;        // BCD codification for minutes, 00-59
    unsigned char   hour;       // BCD codification for hours, 00-24
    unsigned char   weekday;    // BCD codification for day of the week, 00-06
  	};                              // field access
  unsigned char       b[4];       // byte access
  unsigned short      w[2];       // 16 bits access
  unsigned long       l;          // 32 bits access
	} PIC24_RTCC_TIME;



DWORD   PIC24RTCCGetTime( void );
DWORD   PIC24RTCCGetDate( void );
void    PIC24RTCCSetTime( WORD weekDay_hours, WORD minutes_seconds );
void    PIC24RTCCSetDate( WORD xx_year, WORD month_day );
void    UnlockRTCC( void );


BYTE to_bcd(BYTE );
BYTE from_bcd(BYTE );



//cmd #
enum {
	CMD_NOP=0,
	CMD_GETID=1,
	CMD_GETCAPABILITIES=2,
	CMD_GETCONFIG=3,
	CMD_SETCONFIG,

	CMD_GETSTATUS=8,
	CMD_SETSTATUS,

	CMD_TEST=16,
	CMD_BEEP=17,
	CMD_INIT=18,
	CMD_SETFUNCTION,

	CMD_WRITEEEPROM=24,
	CMD_WRITERTC=25,
	CMD_READEEPROM=26,
	CMD_READRTC=27,
	CMD_READTIMESTAMP=28,

	CMD_RESET_IF=30,
	CMD_DEBUG_ECHO=31,
	CMD_READ_IDLOCS=63
	};


// MANUFACTURER_ID=0x115f (ADPM) = 4447

// PRODUCT_IDs
// 0x101=tastiera Mac-Ktronic
// 0x102=tastiera/mouse Ktronic
// 0x103=mouse Interlink (anche PS/2 autosensing) Ktronic
// 0x104=tastiera 6 tasti Ktronic e anche Remote Keyboard ADPM; e Consilium
// 0x105=Terminale USB Ktronic 
// 0x106=tastiera Logitech-Ktronic Multimediale
// 0x107=tastiera Ktronic con canale dati per riconfigurazione ecc.
// 0x108=Composite device (MSC+CDC)KT-ED12 Boagno
// 0x109=Composite device (MSC+CDC)KT-ED11 Boagno
// 0x10a=Tester generico KTronic
// 0x10b=tastiera capacitiva 

// 0x54=demo MSD HID (geco)

// 0x201=Skynet USB RS485
// 0x202=Skynet USB Onde convogliate
// 0x203=Skynet USB Wireless CC900
// 0x204=Skynet USB Wireless Aurel
// 0x20a=Skynet USB simil-ethernet
// 0x210=SkyPIC USB per Eprom tradizionali/parallele/PIC
// 0x220=USB_RELE scheda I/O USB
// 0x230=PELUCHEUSB Giocattolo con MP3/musica, e anche GECO
// 0x231=USBSTEP per pannelli solari
// 0x240=Analizzatore logico USB
// 0x241=USBPower Alimentatore; anche BTAGallerini
// 0x242=generatore di funzioni
// 0x250=VGA clock
// 0x251=TettoRGB e led rgb Rudi
// 0x252=LivioPizzuti's device
// 0x253=USBTime
// 0x254=USBRadio
// 0x255=Oriol's device
// 0x256=Geco tuning device
// 0x257=Manjeevan's device
// 0x260=GSMDevice
// 0x261=Geiger (MSD + HID)
// 0x262=USBthermo (MSD + HID); anche bluetooth ktronic
// 0x263=Caricabatteria Pb(MSD + HID)
// 0x270=USB-CAN
